-- Package declaration
local _errors = _G["errors"] or {}
_G["errors"] = _errors

local builtins = _G.lunar_go_builtins

_errors.New = function(text)
	return setmetatable({ ["s"] = text }, {__index=_errors.errorString})
end

_errors.errorString = {}

_errors.errorString._createFromTable = function(tbl)
	if tbl == nil then
		return nil, nil
	end
	if type(tbl) ~= "table" then
		return nil, builtins.create_error("cannot initialize struct from non-table")
	end
	local self = setmetatable({}, {__index=_errors.errorString})
	local obj, err
	
	self.s = ""
	if type(self.s) == type(tbl.s) then self.s = tbl.s end
	return self, nil
end

_errors.errorString._initializeFromTable = function(self, tbl)
	if tbl == nil then
		return nil
	end
	if type(tbl) ~= "table" then
		return builtins.create_error("cannot initialize struct from non-table")
	end
	local obj, err
		
	if type(self.s) == type(tbl.s) then self.s = tbl.s end
	return nil
end

_errors.errorString.Error = function(e)
	return e.s
end

