-- Package declaration
local _dragons = _G["github.com/eandre/groupauras/auras/emerald_nightmare/dragons"] or {}
_G["github.com/eandre/groupauras/auras/emerald_nightmare/dragons"] = _dragons

local builtins = _G.lunar_go_builtins

local _context = _G["github.com/eandre/groupauras/pkg/context"]
local _draw = _G["github.com/eandre/groupauras/pkg/draw"]
local _auratrack = _G["github.com/eandre/groupauras/pkg/raidutil/auratrack"]
local _rdu = _G["github.com/eandre/groupauras/pkg/raidutil/rdu"]

_dragons.VolatileInfectionID = 203788
_dragons.VolatileInfectionRange = 10

_dragons.Dragons = {}

_dragons.Dragons._createFromTable = function(tbl)
	if tbl == nil then
		return nil, nil
	end
	if type(tbl) ~= "table" then
		return nil, builtins.create_error("cannot initialize struct from non-table")
	end
	local self = setmetatable({}, {__index=_dragons.Dragons})
	local obj, err
	

		obj, err = _auratrack.Tracker._createFromTable(tbl.VolatileInfection)
		if err ~= nil then
			return nil, err
		end
		self.VolatileInfection = obj
					
	return self, nil
end

_dragons.Dragons._initializeFromTable = function(self, tbl)
	if tbl == nil then
		return nil
	end
	if type(tbl) ~= "table" then
		return builtins.create_error("cannot initialize struct from non-table")
	end
	local obj, err
		

		obj, err = _auratrack.Tracker._createFromTable(tbl.VolatileInfection)
		if err ~= nil then
			return err
		end
		self.VolatileInfection = obj
					
	return nil
end

_dragons.Enable = function(ctx)
	local d = { ["Ctx"] = ctx}
	d.VolatileInfection = _auratrack.New(ctx, _dragons.VolatileInfectionID, { ["Add"] = function(target)
		_draw.NewPoint({ ["Ctx"] = target.Ctx, ["Pos"] = _draw.GUIDPosition(target.GUID), ["Text"] = target.Name, ["Texture"] = "highlight", ["SizeYards"] = _dragons.VolatileInfectionRange, ["SizePixels"] = 0, ["RotateDegrees"] = 0, ["RotateSpeed"] = 0, ["DrawLayer"] = "", ["DrawOrder"] = 0})
		_rdu.ShowUnit(target.Ctx, target.GUID)
	end})
	return d
end

