-- Package declaration
local _groupauras = _G["github.com/eandre/groupauras"] or {}
_G["github.com/eandre/groupauras"] = _groupauras

local builtins = _G.lunar_go_builtins

local _aura = _G["github.com/eandre/groupauras/core/aura"]

_groupauras.ProfileConfig = {}

_groupauras.ProfileConfig._createFromTable = function(tbl)
	if tbl == nil then
		return nil, nil
	end
	if type(tbl) ~= "table" then
		return nil, builtins.create_error("cannot initialize struct from non-table")
	end
	local self = setmetatable({}, {__index=_groupauras.ProfileConfig})
	local obj, err
	
	self.RotateMap = false
	if type(self.RotateMap) == type(tbl.RotateMap) then self.RotateMap = tbl.RotateMap end
	self.Auras = nil
	if type(self.Auras) == type(tbl.Auras) then self.Auras = tbl.Auras end
	return self, nil
end

_groupauras.ProfileConfig._initializeFromTable = function(self, tbl)
	if tbl == nil then
		return nil
	end
	if type(tbl) ~= "table" then
		return builtins.create_error("cannot initialize struct from non-table")
	end
	local obj, err
		
	if type(self.RotateMap) == type(tbl.RotateMap) then self.RotateMap = tbl.RotateMap end
	if type(self.Auras) == type(tbl.Auras) then self.Auras = tbl.Auras end
	return nil
end

_groupauras.Config = {}

_groupauras.Config._createFromTable = function(tbl)
	if tbl == nil then
		return nil, nil
	end
	if type(tbl) ~= "table" then
		return nil, builtins.create_error("cannot initialize struct from non-table")
	end
	local self = setmetatable({}, {__index=_groupauras.Config})
	local obj, err
	

		obj, err = _groupauras.ProfileConfig._createFromTable(tbl.profile)
		if err ~= nil then
			return nil, err
		end
		self.profile = obj
					
	return self, nil
end

_groupauras.Config._initializeFromTable = function(self, tbl)
	if tbl == nil then
		return nil
	end
	if type(tbl) ~= "table" then
		return builtins.create_error("cannot initialize struct from non-table")
	end
	local obj, err
		

		obj, err = _groupauras.ProfileConfig._createFromTable(tbl.profile)
		if err ~= nil then
			return err
		end
		self.profile = obj
					
	return nil
end

_groupauras.defaultConfig = { ["profile"] = { ["RotateMap"] = true, ["Auras"] = {  }}}

