-- Package declaration
local _aura = _G["github.com/eandre/groupauras/core/aura"] or {}
_G["github.com/eandre/groupauras/core/aura"] = _aura

local builtins = _G.lunar_go_builtins

_aura.Aura = {}

_aura.Aura._createFromTable = function(tbl)
	if tbl == nil then
		return nil, nil
	end
	if type(tbl) ~= "table" then
		return nil, builtins.create_error("cannot initialize struct from non-table")
	end
	local self = setmetatable({}, {__index=_aura.Aura})
	local obj, err
	
	self.ID = ""
	if type(self.ID) == type(tbl.ID) then self.ID = tbl.ID end
	self.Name = ""
	if type(self.Name) == type(tbl.Name) then self.Name = tbl.Name end
	self.Author = ""
	if type(self.Author) == type(tbl.Author) then self.Author = tbl.Author end
	self.Revision = 0
	if type(self.Revision) == type(tbl.Revision) then self.Revision = tbl.Revision end
	self.Enables = nil
	if type(self.Enables) == type(tbl.Enables) then self.Enables = tbl.Enables end
	self.Disables = nil
	if type(self.Disables) == type(tbl.Disables) then self.Disables = tbl.Disables end
	self.Events = nil
	if type(self.Events) == type(tbl.Events) then self.Events = tbl.Events end
	self.OnUpdate = ""
	if type(self.OnUpdate) == type(tbl.OnUpdate) then self.OnUpdate = tbl.OnUpdate end
	self.OnActivate = ""
	if type(self.OnActivate) == type(tbl.OnActivate) then self.OnActivate = tbl.OnActivate end
	self.OnDeactivate = ""
	if type(self.OnDeactivate) == type(tbl.OnDeactivate) then self.OnDeactivate = tbl.OnDeactivate end
	self.Raw = ""
	if type(self.Raw) == type(tbl.Raw) then self.Raw = tbl.Raw end
	self.Sig = ""
	if type(self.Sig) == type(tbl.Sig) then self.Sig = tbl.Sig end
	return self, nil
end

_aura.Aura._initializeFromTable = function(self, tbl)
	if tbl == nil then
		return nil
	end
	if type(tbl) ~= "table" then
		return builtins.create_error("cannot initialize struct from non-table")
	end
	local obj, err
		
	if type(self.ID) == type(tbl.ID) then self.ID = tbl.ID end
	if type(self.Name) == type(tbl.Name) then self.Name = tbl.Name end
	if type(self.Author) == type(tbl.Author) then self.Author = tbl.Author end
	if type(self.Revision) == type(tbl.Revision) then self.Revision = tbl.Revision end
	if type(self.Enables) == type(tbl.Enables) then self.Enables = tbl.Enables end
	if type(self.Disables) == type(tbl.Disables) then self.Disables = tbl.Disables end
	if type(self.Events) == type(tbl.Events) then self.Events = tbl.Events end
	if type(self.OnUpdate) == type(tbl.OnUpdate) then self.OnUpdate = tbl.OnUpdate end
	if type(self.OnActivate) == type(tbl.OnActivate) then self.OnActivate = tbl.OnActivate end
	if type(self.OnDeactivate) == type(tbl.OnDeactivate) then self.OnDeactivate = tbl.OnDeactivate end
	if type(self.Raw) == type(tbl.Raw) then self.Raw = tbl.Raw end
	if type(self.Sig) == type(tbl.Sig) then self.Sig = tbl.Sig end
	return nil
end

_aura.NewAura = {}

_aura.NewAura._createFromTable = function(tbl)
	if tbl == nil then
		return nil, nil
	end
	if type(tbl) ~= "table" then
		return nil, builtins.create_error("cannot initialize struct from non-table")
	end
	local self = setmetatable({}, {__index=_aura.NewAura})
	local obj, err
	
	self.ID = ""
	if type(self.ID) == type(tbl.ID) then self.ID = tbl.ID end
	self.Name = ""
	if type(self.Name) == type(tbl.Name) then self.Name = tbl.Name end
	self.Author = ""
	if type(self.Author) == type(tbl.Author) then self.Author = tbl.Author end
	self.Revision = 0
	if type(self.Revision) == type(tbl.Revision) then self.Revision = tbl.Revision end
	self.Enables = nil
	if type(self.Enables) == type(tbl.Enables) then self.Enables = tbl.Enables end
	self.Disables = nil
	if type(self.Disables) == type(tbl.Disables) then self.Disables = tbl.Disables end
	return self, nil
end

_aura.NewAura._initializeFromTable = function(self, tbl)
	if tbl == nil then
		return nil
	end
	if type(tbl) ~= "table" then
		return builtins.create_error("cannot initialize struct from non-table")
	end
	local obj, err
		
	if type(self.ID) == type(tbl.ID) then self.ID = tbl.ID end
	if type(self.Name) == type(tbl.Name) then self.Name = tbl.Name end
	if type(self.Author) == type(tbl.Author) then self.Author = tbl.Author end
	if type(self.Revision) == type(tbl.Revision) then self.Revision = tbl.Revision end
	if type(self.Enables) == type(tbl.Enables) then self.Enables = tbl.Enables end
	if type(self.Disables) == type(tbl.Disables) then self.Disables = tbl.Disables end
	return nil
end

