-- Package declaration
local _classutil = _G["github.com/eandre/groupauras/pkg/classutil"] or {}
_G["github.com/eandre/groupauras/pkg/classutil"] = _classutil

local builtins = _G.lunar_go_builtins

local _wow = _G["github.com/eandre/lunar-wow/pkg/wow"]
local _lua = _G["github.com/eandre/lunar/lua"]

_classutil.raidClassColor = {}

_classutil.raidClassColor._createFromTable = function(tbl)
	if tbl == nil then
		return nil, nil
	end
	if type(tbl) ~= "table" then
		return nil, builtins.create_error("cannot initialize struct from non-table")
	end
	local self = setmetatable({}, {__index=_classutil.raidClassColor})
	local obj, err
	
	self.r = 0
	if type(self.r) == type(tbl.r) then self.r = tbl.r end
	self.g = 0
	if type(self.g) == type(tbl.g) then self.g = tbl.g end
	self.b = 0
	if type(self.b) == type(tbl.b) then self.b = tbl.b end
	self.colorStr = ""
	if type(self.colorStr) == type(tbl.colorStr) then self.colorStr = tbl.colorStr end
	return self, nil
end

_classutil.raidClassColor._initializeFromTable = function(self, tbl)
	if tbl == nil then
		return nil
	end
	if type(tbl) ~= "table" then
		return builtins.create_error("cannot initialize struct from non-table")
	end
	local obj, err
		
	if type(self.r) == type(tbl.r) then self.r = tbl.r end
	if type(self.g) == type(tbl.g) then self.g = tbl.g end
	if type(self.b) == type(tbl.b) then self.b = tbl.b end
	if type(self.colorStr) == type(tbl.colorStr) then self.colorStr = tbl.colorStr end
	return nil
end

_classutil.Color = function(unit)
	local _, file = _wow.UnitClassBase(unit)
	_ = file
	local tbl = RAID_CLASS_COLORS[file]
	return tbl.r, tbl.g, tbl.b
end

