-- Package declaration
local _classutil = _G["github.com/eandre/groupauras/pkg/classutil"] or {}
_G["github.com/eandre/groupauras/pkg/classutil"] = _classutil

local builtins = _G.lunar_go_builtins

local _wow = _G["github.com/eandre/lunar-wow/pkg/wow"]

_classutil.RoleDamager = "DAMAGER"
_classutil.RoleHealer = "HEALER"
_classutil.RoleTank = "TANK"


_classutil.SpecInfo = {}

_classutil.SpecInfo._createFromTable = function(tbl)
	if tbl == nil then
		return nil, nil
	end
	if type(tbl) ~= "table" then
		return nil, builtins.create_error("cannot initialize struct from non-table")
	end
	local self = setmetatable({}, {__index=_classutil.SpecInfo})
	local obj, err
	
	self.Name = ""
	if type(self.Name) == type(tbl.Name) then self.Name = tbl.Name end
	self.Class = ""
	if type(self.Class) == type(tbl.Class) then self.Class = tbl.Class end
	self.HasInterrupt = false
	if type(self.HasInterrupt) == type(tbl.HasInterrupt) then self.HasInterrupt = tbl.HasInterrupt end
	self.Melee = false
	if type(self.Melee) == type(tbl.Melee) then self.Melee = tbl.Melee end
	self.Role = ""
	if type(self.Role) == type(tbl.Role) then self.Role = tbl.Role end
	return self, nil
end

_classutil.SpecInfo._initializeFromTable = function(self, tbl)
	if tbl == nil then
		return nil
	end
	if type(tbl) ~= "table" then
		return builtins.create_error("cannot initialize struct from non-table")
	end
	local obj, err
		
	if type(self.Name) == type(tbl.Name) then self.Name = tbl.Name end
	if type(self.Class) == type(tbl.Class) then self.Class = tbl.Class end
	if type(self.HasInterrupt) == type(tbl.HasInterrupt) then self.HasInterrupt = tbl.HasInterrupt end
	if type(self.Melee) == type(tbl.Melee) then self.Melee = tbl.Melee end
	if type(self.Role) == type(tbl.Role) then self.Role = tbl.Role end
	return nil
end

_classutil.UnknownSpec = { ["Name"] = "Unknown", ["Class"] = "UNKNOWN", ["Melee"] = false, ["HasInterrupt"] = false, ["Role"] = _classutil.RoleDamager}

_classutil.Specs = { [0] = _classutil.UnknownSpec, [62] = { ["Name"] = "Arcane", ["Class"] = "MAGE", ["HasInterrupt"] = true, ["Melee"] = false, ["Role"] = _classutil.RoleDamager}, [63] = { ["Name"] = "Fire", ["Class"] = "MAGE", ["HasInterrupt"] = true, ["Melee"] = false, ["Role"] = _classutil.RoleDamager}, [64] = { ["Name"] = "Frost", ["Class"] = "MAGE", ["HasInterrupt"] = true, ["Melee"] = false, ["Role"] = _classutil.RoleDamager}, [65] = { ["Name"] = "Holy", ["Class"] = "PALADIN", ["HasInterrupt"] = false, ["Melee"] = true, ["Role"] = _classutil.RoleHealer}, [66] = { ["Name"] = "Protection", ["Class"] = "PALADIN", ["HasInterrupt"] = true, ["Melee"] = true, ["Role"] = _classutil.RoleTank}, [70] = { ["Name"] = "Retribution", ["Class"] = "PALADIN", ["HasInterrupt"] = true, ["Melee"] = true, ["Role"] = _classutil.RoleDamager}, [71] = { ["Name"] = "Arms", ["Class"] = "WARRIOR", ["HasInterrupt"] = true, ["Melee"] = true, ["Role"] = _classutil.RoleDamager}, [72] = { ["Name"] = "Fury", ["Class"] = "WARRIOR", ["HasInterrupt"] = true, ["Melee"] = true, ["Role"] = _classutil.RoleDamager}, [73] = { ["Name"] = "Protection", ["Class"] = "WARRIOR", ["HasInterrupt"] = true, ["Melee"] = true, ["Role"] = _classutil.RoleTank}, [102] = { ["Name"] = "Balance", ["Class"] = "DRUID", ["HasInterrupt"] = false, ["Melee"] = false, ["Role"] = _classutil.RoleDamager}, [103] = { ["Name"] = "Feral", ["Class"] = "DRUID", ["HasInterrupt"] = true, ["Melee"] = true, ["Role"] = _classutil.RoleDamager}, [104] = { ["Name"] = "Guardian", ["Class"] = "DRUID", ["HasInterrupt"] = true, ["Melee"] = true, ["Role"] = _classutil.RoleTank}, [105] = { ["Name"] = "Restoration", ["Class"] = "DRUID", ["HasInterrupt"] = false, ["Melee"] = false, ["Role"] = _classutil.RoleHealer}, [250] = { ["Name"] = "Blood", ["Class"] = "DEATHKNIGHT", ["HasInterrupt"] = true, ["Melee"] = true, ["Role"] = _classutil.RoleTank}, [251] = { ["Name"] = "Frost", ["Class"] = "DEATHKNIGHT", ["HasInterrupt"] = true, ["Melee"] = true, ["Role"] = _classutil.RoleDamager}, [252] = { ["Name"] = "Unholy", ["Class"] = "DEATHKNIGHT", ["HasInterrupt"] = true, ["Melee"] = true, ["Role"] = _classutil.RoleDamager}, [253] = { ["Name"] = "Beast Mastery", ["Class"] = "HUNTER", ["HasInterrupt"] = true, ["Melee"] = false, ["Role"] = _classutil.RoleDamager}, [254] = { ["Name"] = "Marksmanship", ["Class"] = "HUNTER", ["HasInterrupt"] = true, ["Melee"] = false, ["Role"] = _classutil.RoleDamager}, [255] = { ["Name"] = "Survival", ["Class"] = "HUNTER", ["HasInterrupt"] = true, ["Melee"] = false, ["Role"] = _classutil.RoleDamager}, [256] = { ["Name"] = "Discipline", ["Class"] = "PRIEST", ["HasInterrupt"] = false, ["Melee"] = false, ["Role"] = _classutil.RoleHealer}, [257] = { ["Name"] = "Holy", ["Class"] = "PRIEST", ["HasInterrupt"] = false, ["Melee"] = false, ["Role"] = _classutil.RoleHealer}, [258] = { ["Name"] = "Shadow", ["Class"] = "PRIEST", ["HasInterrupt"] = false, ["Melee"] = false, ["Role"] = _classutil.RoleDamager}, [259] = { ["Name"] = "Assassination", ["Class"] = "ROGUE", ["HasInterrupt"] = true, ["Melee"] = true, ["Role"] = _classutil.RoleDamager}, [260] = { ["Name"] = "Combat", ["Class"] = "ROGUE", ["HasInterrupt"] = true, ["Melee"] = true, ["Role"] = _classutil.RoleDamager}, [261] = { ["Name"] = "Subtlety", ["Class"] = "ROGUE", ["HasInterrupt"] = true, ["Melee"] = true, ["Role"] = _classutil.RoleDamager}, [262] = { ["Name"] = "Elemental", ["Class"] = "SHAMAN", ["HasInterrupt"] = true, ["Melee"] = false, ["Role"] = _classutil.RoleDamager}, [263] = { ["Name"] = "Enhancement", ["Class"] = "SHAMAN", ["HasInterrupt"] = true, ["Melee"] = true, ["Role"] = _classutil.RoleDamager}, [264] = { ["Name"] = "Restoration", ["Class"] = "SHAMAN", ["HasInterrupt"] = true, ["Melee"] = false, ["Role"] = _classutil.RoleHealer}, [265] = { ["Name"] = "Affliction", ["Class"] = "WARLOCK", ["HasInterrupt"] = false, ["Melee"] = false, ["Role"] = _classutil.RoleDamager}, [266] = { ["Name"] = "Demonology", ["Class"] = "WARLOCK", ["HasInterrupt"] = false, ["Melee"] = false, ["Role"] = _classutil.RoleDamager}, [267] = { ["Name"] = "Destruction", ["Class"] = "WARLOCK", ["HasInterrupt"] = false, ["Melee"] = false, ["Role"] = _classutil.RoleDamager}, [268] = { ["Name"] = "Brewmaster", ["Class"] = "MONK", ["HasInterrupt"] = true, ["Melee"] = true, ["Role"] = _classutil.RoleTank}, [269] = { ["Name"] = "Windwalker", ["Class"] = "MONK", ["HasInterrupt"] = true, ["Melee"] = true, ["Role"] = _classutil.RoleDamager}, [270] = { ["Name"] = "Mistweaver", ["Class"] = "MONK", ["HasInterrupt"] = false, ["Melee"] = false, ["Role"] = _classutil.RoleHealer}, [577] = { ["Name"] = "Havoc", ["Class"] = "DEMONHUNTER", ["HasInterrupt"] = true, ["Melee"] = true, ["Role"] = _classutil.RoleDamager}, [581] = { ["Name"] = "Vengeance", ["Class"] = "DEMONHUNTER", ["HasInterrupt"] = true, ["Melee"] = true, ["Role"] = _classutil.RoleTank} }

